/*--------------------------------------------------------------------------+
$Id: Left_StickXExecutable.java 22461 2017-12-07 12:52:48Z hoelzl $
|                                                                          |
| Copyright 2017 fortiss GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.generator.executable.rumblepad;

import static org.fortiss.af3.expression.utils.ExpressionModelElementFactory.funcCall;

import org.fortiss.af3.component.model.InputPort;
import org.fortiss.af3.expression.model.terms.IExpressionTerm;
import org.fortiss.af3.platform.language.executable.ReceiverExecutableBase;
import org.fortiss.af3.platform.raspberry.model.rumblepad.Left_StickX_Position;

/**
 * Executable for {@link Left_StickX_Position}.
 * 
 * @author eder
 * @author $Author: hoelzl $
 * @version $Rev: 22461 $
 * @ConQAT.Rating RED Hash:
 */
public class Left_StickXExecutable extends ReceiverExecutableBase<Left_StickX_Position> {

	/** Constructor. */
	public Left_StickXExecutable(Left_StickX_Position modelElement) {
		super(modelElement);
	}

	public IExpressionTerm getInitialization() {
		return funcCall("rp_init");
	}

	public IExpressionTerm getNoValGuardAccessor(InputPort logicalSignal) {
		return funcCall("rp_btnLX_is_noval");
	}

	public IExpressionTerm getTermination() {
		return funcCall("rp_term");
	}

	public IExpressionTerm getValueReadAccessor(InputPort logicalSignal) {
		return funcCall("rp_btnLX_read");
	}
}
