/*--------------------------------------------------------------------------+
$Id: ButtonL3Transformation.java 22462 2017-12-07 13:24:17Z hoelzl $
|                                                                          |
| Copyright 2017 fortiss GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.generator.transform.rumblepad;

import org.fortiss.af3.platform.raspberry.generator.executable.rumblepad.ButtonL3Executable;
import org.fortiss.af3.platform.raspberry.model.rumblepad.ButtonL3;
import org.fortiss.tooling.kernel.extension.ITransformationProvider;
import org.fortiss.tooling.kernel.extension.data.ITransformationContext;

/**
 * Transformation for {@link ButtonL3}.
 * 
 * @author eder
 * @author $Author: hoelzl $
 * @version $Rev: 22462 $
 * @ConQAT.Rating RED Hash:
 */
public class ButtonL3Transformation implements ITransformationProvider {

	/** {@inheritDoc} */
	@Override
	public Class<?> getTargetClass() {
		return ButtonL3Executable.class;
	}

	/** {@inheritDoc} */
	@Override
	public boolean
			canHandleChainTransformation(Class<?> sourceClass, ITransformationContext context) {
		return ButtonL3.class.isAssignableFrom(sourceClass);
	}

	/** {@inheritDoc} */
	@Override
	public boolean canTransform(Object source, ITransformationContext context) {
		return source instanceof ButtonL3;
	}

	/** {@inheritDoc} */
	@Override
	public Object transform(Object source, ITransformationContext context) {
		return new ButtonL3Executable((ButtonL3)source);
	}

}
