/*--------------------------------------------------------------------------+
$Id: SimpleRumbleFeatureTransformation.java 22478 2017-12-08 09:55:32Z hoelzl $
|                                                                          |
| Copyright 2017 fortiss GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.generator.transform.rumblepad;

import org.fortiss.af3.platform.raspberry.generator.executable.rumblepad.SimpleRumbleFeatureExecutable;
import org.fortiss.af3.platform.raspberry.model.rumblepad.SimpleRumbleFeature;
import org.fortiss.tooling.kernel.extension.ITransformationProvider;
import org.fortiss.tooling.kernel.extension.data.ITransformationContext;

/**
 * Transformation for {@link SimpleRumbleFeature}.
 */
public class SimpleRumbleFeatureTransformation implements ITransformationProvider {

	/** {@inheritDoc} */
	@Override
	public Class<?> getTargetClass() {
		return SimpleRumbleFeatureExecutable.class;
	}

	/** {@inheritDoc} */
	@Override
	public boolean
			canHandleChainTransformation(Class<?> sourceClass, ITransformationContext context) {
		return SimpleRumbleFeature.class.isAssignableFrom(sourceClass);
	}

	/** {@inheritDoc} */
	@Override
	public boolean canTransform(Object source, ITransformationContext context) {
		return source instanceof SimpleRumbleFeature;
	}

	/** {@inheritDoc} */
	@Override
	public Object transform(Object source, ITransformationContext context) {
		return new SimpleRumbleFeatureExecutable((SimpleRumbleFeature)source);
	}

}
